program define BNT, rclass
syntax varlist, kmax(real) 
//input: varlist: n variables with t observations each
//        kmax is the maximum factor number
//output: the optimal factor number
//        Three criterions are using

mata:y=st_data(.,tokens("`varlist'"))
mata:y=y //for N by T data
mata:kmax=`kmax'
mata:n=cols(y)
mata:t=rows(y)
mata:y[,] = y :- mean(y)
mata:vy=y'*y/(t*n)
mata:ve=J(n,n,0)
mata:va=J(n,1,0)
mata:ve1=J(n,n,0)
mata:fullsvd(vy,ve,va,ve1)

mata: v0=csum(va,kmax)

 mata: c=min((sqrt(n),sqrt(t)))
 mata:ks=0::kmax
 mata:ic1 = ln(v0) :+ ks:*((n+t)/(n*t))*ln((n*t)/(2*(n+t)))
 mata:ic2 = ln(v0) :+ ks:*((n+t)/(n*t))*2*ln(c)
 mata:ic3 = ln(v0) :+ ks:*(2*ln(c)/(c*c))

 mata: i=0
 mata:w=0
 mata: minindex(ic1, 1, i, w)
 mata: k1 = i - 1;
 mata:  minindex(ic2, 1, i, w)
 mata:k2 = i - 1;
 mata:minindex(ic3, 1, i, w)
 mata:k3 = i - 1;
 mata:st_numscalar("k1",k1)
 mata:st_numscalar("k2",k2)
 mata:st_numscalar("k3",k3)
 
return scalar k1=k1
return scalar k2=k2
return scalar k3=k3
 disp " Use Bai&Ng's IC2"
 disp "  Bai&Ng's   IC1      :  " k1
 disp "  Bai&Ng's   IC2      :  " k2
 disp "  Bai&Ng's   IC3      :  " k3
 end

 
 mata:

real matrix stand (real matrix y,real scalar s)
{
real scalar tt,nn
real matrix x
  tt = rows(y)
  nn = cols(y)
  x=J(tt,nn,0)
if (s==1)  {
	x[,] = y :/ sqrt(diagonal(variance(y))')
    x[,] = y :- mean(y)        
	           }
    else if (s!=1) {
			x=y
				    }	
return(x)
}

end
 
 mata:

real matrix csum (real vector va,real scalar kmax)
{
real matrix v0

v0 = J(kmax+1,1,0)
for (i=1; i<=kmax+1; i++) { 
v0[i] = sum(va[i::rows(va)])
}
return(v0)
}

end
