clear
insheet using pce1.csv, comma
xtset id year
gen      p = pce
gen     dp = (p - L.p) / L.p
egen sd_dp = sd(dp), by(id)
gen   dps = dp / sd_dp

gen     dp2 = dp - L.dp
egen sd_dp2 = sd(dp2), by(id)
gen   dp2s = dp2 / sd_dp2
drop if year < 1980

//leadership model
keep dp2s id year
egen mp2 = mean(dp2s), by(year)
reshape wide dp2s mp2, i(year) j(id)

qui reg mp21 dp2s47 dp2s48 dp2s49
qui predict fitted
gen hmp2 = fitted

forvalue i=1/46 {
  qui reg dp2s`i' hmp2
  qui predict resid`i'
 }
BNT resid1-resid46, kmax(8)  
