
program define ps,rclass
syntax varlist, k(real) kk(real)
//input: varlist: t variables with n observations for each
//       N by T matrix                 
//       k is the factor number
//      
//output: 

mata:y=st_data(.,tokens("`varlist'"))
mata:k=`k'
mata: kk=`kk'
mata:x=y[.,kk+1::cols(y)] 
mata: y1 = y[.,1::kk] 
mata: index = psi(x,y,k)
//index = psloop(x,y1,k) 
mata:st_matrix("index",index)
return matrix index=index

//mata:st_matrix("z",z)
//mata:st_numscalar("k1",k1)

//return matrix z=z
//return scalar k1=k1
//disp " Use Parker and Sul"
//disp " k1  :  " r(k1)
end



mata:
real matrix psi(real matrix x, real matrix y1, real scalar k)
{  
  real scalar n,t,k1
  real matrix xx, z
   
  t = rows(x);
  n = cols(x);
  
  xx = J(t,1,1),y1;
  z = x - xx*invsym(xx'xx)*xx'*x;
  k1 = bcn(z,k); 
return(k1)
}
end


mata:
real matrix bcn (real matrix x, real scalar kmax)
{
  real scalar n,t,c,i,w,k2
  real matrix vx,ve,va,ve1,v0,ks,ic2

  n=cols(x)
  t=rows(x)
  x[,] = x :- mean(x)
  vx=x'*x/(t*n)
  ve=J(n,n,0)
  va=J(n,1,0)
  ve1=J(n,n,0)
  fullsvd(vx,ve,va,ve1)

  v0=csum(va,kmax)

  c=min((sqrt(n),sqrt(t)))
   ks=0::kmax
    ic2 = ln(v0) :+ ks:*((n+t)/(n*t))*2*ln(c)
   i=0
   w=0
   minindex(ic2, 1, i, w)
   k2 = i - 1;
 
return(k2)
}
end

mata:

real matrix csum (real vector va,real scalar kmax)
{
real matrix v0

v0 = J(kmax+1,1,0)
for (i=1; i<=kmax+1; i++) { 
v0[i] = sum(va[i::rows(va)])
}
return(v0)
}

end

mata:

real matrix psloop (real matrix x,real matrix y, real scalar k)
{
real matrix v0,z
real scalar n,t,k1

n=cols(y)
t=rows(y)
x[,] = x :/ sqrt(diagonal(variance(x))')
k1 = psi(x,y,k);
return(k1)
}

end

