program define weaks,rclass
syntax varlist, lag(real) 
//input: varlist: t variables with n observations each
//                n by t  matrix
//        lag is the lag number used in newey west estimation
//output: trend regression coefficient and the t-ratio

mata:y=st_data(.,tokens("`varlist'"))
mata:y = y';
mata:lag=`lag'
mata:t=rows(y)
mata:n=cols(y)
mata:y=y:-mean(y')'
mata:y=y:*y
mata:y=mean(y')'
mata:tt=1::t

mata:xx = J(t,1,1),tt;
mata:be = invsym(xx'xx)*xx'*y;
mata:re = y - xx*be;
mata:sig = nwest(re,lag);
mata:vari = sig*invsym(xx'xx);
mata:te = be[2]/sqrt(vari[2,2]);

mata:st_numscalar("b2",be[2])
mata:st_numscalar("t2",te)

return scalar b2=b2
return scalar t2=t2
disp "-------------------------------------------------------------"
disp "             bhat     :  " b2
disp "             t-ratio  :  " t2
disp "-------------------------------------------------------------"
end
   
 mata:

real matrix nwest (real vector x,real scalar lag)
{
real scalar t, xom,xomm,temp11
   t = rows(x)
   xom= (x'*x)/t
   xomm = 0;
  for (i=1; i<=lag; i++) { 
      temp11 = sum(x[1+i::t-1,.]:*x[1::t-1-i,.])
      xomm = (1-(i/(lag+1)))*(temp11/t) + xomm
                            }  
     xom = xom +2*xomm

return(xom)
}

end
   
   
   
   
 